#version 330 

layout (location = 0) out vec4 fragColor;
layout (location = 1) out vec4 brightColor;

uniform sampler2D gSampler; 

smooth in vec2 vTexCoord; 
flat in vec4 vColorPart;

void main() 
{ 
  vec4 vTexColor = texture2D(gSampler, vTexCoord); 
  fragColor = vTexColor * vColorPart;

  float brightness = dot(fragColor.rgb, vec3(0.2126, 0.7152, 0.0722));
  if(brightness > 0.8)
	brightColor = fragColor;
}