#version 330 core

in vec2 TexCoords;
out vec4 fragColor;

uniform float fade;

uniform sampler2D screenTexture;
uniform sampler2D bloomTexture;

void main()
{ 
    vec3 color = texture(screenTexture, TexCoords).rgb;      
    vec3 bloomColor = texture(bloomTexture, TexCoords).rgb;
    color += bloomColor; // additive blending

    fragColor = vec4(color * fade, 1.0);
}