#version 330 core

in vec3 position;
in vec3 normal;
in vec2 uv;

in vec3 tangent;
in vec3 biTangent;

out vec2 textureCoord;
out vec3 P;
out vec3 N;

out mat3 localSurface2World;

uniform vec3 color = vec3(1.0,1.0,1.0);

uniform mat4 model;
uniform mat4 projection;
uniform mat4 view;

void main(){
	
	textureCoord = uv;

	mat4 normalMatrix = inverse(transpose(model));
	vec3 worldNormal = normalize( (normalMatrix * vec4(normal, 0.0)).xyz );
	gl_Position = projection * view * model * vec4(position, 1.0);

	N = normalize(worldNormal);
	P = ( model * vec4(position, 1.0) ).xyz;

	// calculate TBN Matrix
	vec3 _T = normalize((model * vec4(tangent,   0.0)).xyz);
	vec3 _N = normalize((model * vec4(normal,    0.0)).xyz);
	vec3 _B = normalize(cross(_N, _T));
	//vec3 _B = normalize(vec3(model * vec4(biTangent,    0.0)));//
	localSurface2World = mat3(_T, _B, _N);
}