#version 330 core

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec2 textureCoord;
out vec3 P;
out vec3 N;

uniform mat4 model;
uniform mat4 projection;
uniform mat4 view;

void main()
{
	textureCoord = uv;

	mat4 normalMatrix = inverse(transpose(model));
	vec3 worldNormal = normalize( (normalMatrix * vec4(normal, 0.0)).xyz );
	gl_Position = projection * view * model * vec4(position, 1.0);

	N = normalize(worldNormal);
	P = ( model * vec4(position, 1.0) ).xyz;
}